unit U_ContractListXF;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter,
  RM_Dataset, RM_System, RM_Common, RM_Class, RM_GridReport, RM_e_Xls,
  Menus, cxPC, cxButtonEdit, cxTextEdit, cxCurrencyEdit, RM_e_Graphic,
  RM_e_Jpeg, cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore,
  dxSkinsDefaultPainters, dxSkinscxPCPainter, cxNavigator, dxBarBuiltInMenu;

type
  TfrmContractList_XF = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    TBDel: TToolButton;
    TBPrint: TToolButton;
    TBClose: TToolButton;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    TBExport: TToolButton;
    v1OrdDate: TcxGridDBColumn;
    v1DeliveryDate: TcxGridDBColumn;
    v1ConPerson1: TcxGridDBColumn;
    v1ConNo: TcxGridDBColumn;
    v1MPRTSpec: TcxGridDBColumn;
    Order_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBDataSet1: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    v1CustomerNoName: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    v1OrdDefStr1: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Tcopy: TToolButton;
    ADOQueryPrint: TADOQuery;
    CDS_Print: TClientDataSet;
    v1Column4: TcxGridDBColumn;
    PopupMenu2: TPopupMenu;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CustomerNo: TEdit;
    ConPerson1: TEdit;
    MPRTCodeName: TEdit;
    ConNoM: TEdit;
    MPRTKZ: TEdit;
    MPRTMF: TEdit;
    v1Column2: TcxGridDBColumn;
    v1QianDPlace: TcxGridDBColumn;
    cxTabControl1: TcxTabControl;
    TTJ: TToolButton;
    TnoTJ: TToolButton;
    cxSplitter1: TcxSplitter;
    ADOQuerySub: TADOQuery;
    DataSource2: TDataSource;
    Panel4: TPanel;
    Label14: TLabel;
    Panel10: TPanel;
    Image2: TImage;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RMJPEGExport1: TRMJPEGExport;
    v1CustomerNo: TcxGridDBColumn;
    Label6: TLabel;
    CustomerNoName: TEdit;
    Label2: TLabel;
    ShippMent: TEdit;
    v1QtyNote: TcxGridDBColumn;
    Label7: TLabel;
    QtyNote: TEdit;
    v1ShippMent: TcxGridDBColumn;
    v1ConMoney: TcxGridDBColumn;
    v1pichang: TcxGridDBColumn;
    Panel2: TPanel;
    DataSource3: TDataSource;
    Order_RL: TClientDataSet;
    v1SJFHMoney: TcxGridDBColumn;
    v1RLRMBMoney: TcxGridDBColumn;
    v1RLUSDMoney: TcxGridDBColumn;
    order_Sub: TClientDataSet;
    v1OrderNo: TcxGridDBColumn;
    Label3: TLabel;
    OrderNo: TEdit;
    ToolButton2: TToolButton;
    v1ifFJ: TcxGridDBColumn;
    v1ConType: TcxGridDBColumn;
    Label11: TLabel;
    ConType: TComboBox;
    ClientDataSet1: TClientDataSet;
    v1KHConNO: TcxGridDBColumn;
    Label15: TLabel;
    KHConNO: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    v1PrtCode: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1PRTCodeNameEng: TcxGridDBColumn;
    v1PRTspec: TcxGridDBColumn;
    v1PRTMF: TcxGridDBColumn;
    v1PRTKZ: TcxGridDBColumn;
    v1PRTColor: TcxGridDBColumn;
    v1SOrdDefStr4: TcxGridDBColumn;
    v1HXQty: TcxGridDBColumn;
    v1ColQty: TcxGridDBColumn;
    v1MSQty: TcxGridDBColumn;
    cxGridDBColumn1: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    v1HYPrice: TcxGridDBColumn;
    v1YJBLi: TcxGridDBColumn;
    v1YJPrice: TcxGridDBColumn;
    v1PRTPrice: TcxGridDBColumn;
    v1ConMXMoney: TcxGridDBColumn;
    v1PriceUnit: TcxGridDBColumn;
    v1TiaoQty: TcxGridDBColumn;
    v1ZXChiCun: TcxGridDBColumn;
    v1MXTQty: TcxGridDBColumn;
    v1MaoQty: TcxGridDBColumn;
    v1JQty: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    v2XQty: TcxGridDBColumn;
    v2PKGFee: TcxGridDBColumn;
    v2MXNote: TcxGridDBColumn;
    v2PRTHX: TcxGridDBColumn;
    v2StyleNo: TcxGridDBColumn;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    v1IFCK: TcxGridDBColumn;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    v2PRTGY: TcxGridDBColumn;
    v2BZYQNote: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Tv1CellDblClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure TBTPClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Tv1StylesGetContentStyle(Sender: TcxCustomGridTableView;
      ARecord: TcxCustomGridRecord; AItem: TcxCustomGridTableItem;
      out AStyle: TcxStyle);
    procedure v1DeliveryDateCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure TcopyClick(Sender: TObject);
    procedure CustomerNoChange(Sender: TObject);
    procedure ConNoMKeyPress(Sender: TObject; var Key: Char);
    procedure cxTabControl1Change(Sender: TObject);
    procedure TTJClick(Sender: TObject);
    procedure TnoTJClick(Sender: TObject);
    procedure Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView;
      APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord;
      ANewItemRecordFocusingChanged: Boolean);
    procedure Image2Click(Sender: TObject);
    procedure TBPrintClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
  private
    DQdate:TDateTime;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    procedure InitGridFH();
    procedure SetStatus();
    procedure InitSub();
    { Private declarations }
  public
    FFInt,FCloth:Integer;
    canshu1,Canshu2:string;
    { Public declarations }
  end;

var
  frmContractList_XF: TfrmContractList_XF;

implementation
uses
  U_DataLink,U_ConInPutXF,U_Fun,U_ZDYHelp,U_SKCR_CX,U_FjList_RZ;

{$R *.dfm}
procedure TfrmContractList_XF.InitSub();
begin
  IF Order_Main.IsEmpty then exit;
  with ADOQuerySub do
  begin
    close;
    sql.Clear;
    sql.Add('select * from JYOrderCon_sub ');
    sql.Add('where mainID ='+quotedstr((Order_Main.fieldbyname('mainID').AsString)));
    open;
  end;
  SCreateCDS20(ADOQuerySub,Order_Sub);
  SInitCDSData20(ADOQuerySub,Order_Sub);
end;

procedure TfrmContractList_XF.SetStatus();
begin
  tTJ.Visible:=false;
  tnoTJ.Visible:=false;
  tbedit.Visible:=false;
  tbdel.Visible:=false;
  TBAdd.Visible:=false;
  Tcopy.Visible:=false;
  TBPrint.Visible:=false;
  if canshu2<>'查询' then
  begin
    TBAdd.Visible:=true;
    Tcopy.Visible:=true;
    case cxTabControl1.TabIndex of
    0:begin
       tbedit.Visible:=true;
       tbdel.Visible:=true;
       tTJ.Visible:=true;
      end;
    1:begin
        TnoTJ.Visible:=True;
      end;
    2:begin
        TBPrint.Visible:=true;
      end;
    3:begin

      end;
    end;
  end;
  if Trim(canshu1)='高权限'  then
  begin
    tbedit.Visible:=true;
    tbdel.Visible:=true;
    TBAdd.Visible:=true;
    Tcopy.Visible:=true;
    TBPrint.Visible:=true;
  end;
end;

procedure TfrmContractList_XF.FormDestroy(Sender: TObject);
begin
  frmContractList_XF:=nil;
end;

procedure TfrmContractList_XF.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmContractList_XF.FormCreate(Sender: TObject);
begin
  cxgrid1.Align:=alClient;
  //BegDate.DateTime:=SGetServerDateTime(ADOQueryTemp)-7;
  //EndDate.DateTime:=SGetServerDateTime(ADOQueryTemp);
  DQdate:=SGetServerDate(ADOQueryTemp);
  cxTabControl1.TabIndex:=0;
  canshu1:=trim(DParameters1);
  Canshu2:=trim(DParameters2);
end;

procedure TfrmContractList_XF.TBCloseClick(Sender: TObject);
begin
  Close;
  if FCloth<>1 then
    WriteCxGrid('订单合同列表',Tv1,'生产指示单管理')
  else
    WriteCxGrid('订单合同列表选择',Tv1,'生产指示单管理');
end;

procedure TfrmContractList_XF.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add('select distinct A.*,A.ConNo ConNoM ');
      sql.add(',SJFHMoney=(select Sum(B.Money) from YF_Money_CR B where B.CRType=''应收款登记'' and B.ConNO=A.ConNO) ');
      sql.add(',RLRMBMoney=(select Sum(RLMoney) from JYOrderYSK S where S.Mainid=A.Mainid and S.BZType=''￥'')');
      sql.add(',RLUSDMoney=(select Sum(RLMoney) from JYOrderYSK S where S.Mainid=A.Mainid and S.BZType=''$'')');
      SQL.Add(',PRTOrderQty=(select Sum(PRTOrderQty) from JYOrderCon_Sub B where B.MainId=A.MainId)');
      SQL.Add(',ConMoney=(select Sum(PRTOrderQty*PRTPrice) from JYOrderCon_Sub B where B.MainId=A.MainId)');
      SQL.Add(',OrderUnit=(select top 1 OrderUnit from JYOrderCon_Sub B where B.MainId=A.MainId)');
      SQL.Add(',PriceUnit=(select top 1 PriceUnit from JYOrderCon_Sub B where B.MainId=A.MainId)');
      SQL.Add(',PRTPrice=(select top 1 PRTPrice from JYOrderCon_Sub B where B.MainId=A.MainId)');
      SQL.Add(',OrderNo=(select top 1 OrderNo from JYOrder_Main B where B.ConNO=A.ConNO)');
      SQL.Add(',ifFJ=(case when isnull((select Top 1 WBID from TP_File B where B.WBID=A.ConNo and B.TFType=''合同''),'''')='''' then ''否'' else ''是'' end)');
      sql.Add(' from JYOrderCon_Main A ');
      SQL.Add('where  A.fILLtIME>='''+FormatDateTime('yyyy-MM-dd',BegDate.DateTime)+'''');
      SQL.Add('and  A.fILLtIME<'''+FormatDateTime('yyyy-MM-dd',enddate.DateTime+1)+'''');
      sql.Add(' and A.MPRTType=''外销'' ');
      if Trim(canshu1)<>'高权限'  then
      begin
        sql.Add('and A.ConPerson1='''+Trim(DName)+'''');
      end;
      IF cxTabControl1.TabIndex<4 then
      begin
        sql.Add(' and  isnull(A.status,''0'')='''+inttostr(cxTabControl1.TabIndex)+'''');
      end;
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
  finally;
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmContractList_XF.InitGridFH();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add('exec Order_QryList :MainId,:WSql');
      Parameters.ParamByName('WSql').Value:=' and FillTime>='''+Trim(FormatDateTime('yyyy-MM-dd',BegDate.DateTime))+''''
                                           +' and FillTime<'''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.DateTime+1))+'''';
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmContractList_XF.InitForm();
begin
  if FCloth<>1 then
    ReadCxGrid('订单合同列表',Tv1,'生产指示单管理')
  else
    ReadCxGrid('订单合同列表选择',Tv1,'生产指示单管理');

  if FCloth=1 then
  begin
    v1Column4.Visible:=True;
 //   v1PRTPrice.Visible:=False;
   // v1PRTPrice.Hidden:=True;
  end else
  begin
    v1Column4.Visible:=False;
  //  v1PRTPrice.Visible:=True;
  //  v1PRTPrice.Hidden:=False;
  end;
  BegDate.DateTime:=SGetServerDate10(ADOQueryTemp)-30;
  EndDate.DateTime:=SGetServerDate10(ADOQueryTemp);
  InitGrid();
end;

procedure TfrmContractList_XF.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmContractList_XF.TBEditClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(Order_Main.fieldbyname('filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('不能操作他人的数据!','提示',0);
    Exit;
  end;
  try
    frmConInPutXF:=TfrmConInPutXF.Create(Application);
    with frmConInPutXF do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmConInPutXF.Free;
  end;
end;

procedure TfrmContractList_XF.TBDelClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(Order_Main.fieldbyname('filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('不能操作他人的数据!','提示',0);
    Exit;
  end;
    with ADOQueryTemp do
    begin
      close;
      sql.Clear;
      sql.add('select * from JYOrder_Main where ConNo='''+trim(Order_Main.fieldbyname('ConNo').AsString)+''' ');
      open;
      if not isempty then
      begin
        application.MessageBox('已生成指示单，不能删除','提示');
        exit;
      end;
    end;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  if DelData() then
  begin
    Order_Main.Delete;
  end;
end;

function TfrmContractList_XF.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;

    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete JYOrderCon_Sub where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('delete JYOrderCon_Main where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('外销合同删除')));
      sql.Add(','+quotedstr(trim('合同号：'+trim(Order_Main.FieldByName('conNo').AsString))));
      sql.Add(','+quotedstr(trim('成功')));
      sql.Add(')');
      ExecSQL;
    end;

    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('数据删除异常！','提示',0);
  end;
end;

procedure TfrmContractList_XF.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv1,ADOQueryMain,'生产指示单列表');
end;

procedure TfrmContractList_XF.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmContractList_XF.TBAddClick(Sender: TObject);
var
  maxno:string;
begin
  try
    frmConInPutXF:=TfrmConInPutXF.Create(Application);
    with frmConInPutXF do
    begin
      PState:=0;
      FMainId:='';
      if ShowModal=1 then
      begin

      end;
      TBRafresh.Click;
    end;
  finally
    frmConInPutXF.Free;
  end;
end;

procedure TfrmContractList_XF.FormShow(Sender: TObject);
begin
  SetStatus();
  InitForm();

end;

procedure TfrmContractList_XF.Tv1CellDblClick(
  Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  if ToolButton1.Visible=False then Exit;
  ToolButton1.Click;
end;

procedure TfrmContractList_XF.TBTPClick(Sender: TObject);
 var
   FQty,FQty1,FMxQty,FPQty,FMxQtyS,FPQtyS:String;
begin
end;

procedure TfrmContractList_XF.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmContractList_XF.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmContractList_XF.Tv1StylesGetContentStyle(
  Sender: TcxCustomGridTableView; ARecord: TcxCustomGridRecord;
  AItem: TcxCustomGridTableItem; out AStyle: TcxStyle);
var
  id,id10:Integer;
begin
  {try
    if Tv1.GroupedItemCount=0 then
    begin
      Id:=Tv1.GetColumnByFieldName('DeliveryDate').Index-tv1.GroupedItemCount;
      Id10:=Tv1.GetColumnByFieldName('SubStatus').Index-tv1.GroupedItemCount;
      if Trim(VarToStr(ARecord.Values[id]))='' then Exit;
      if Id<0 then Exit;
      if ARecord.Values[id10]='完成' then exit;
      if (ARecord.Values[id]-DQdate)>=4 then Exit;
      if ((ARecord.Values[id]-DQdate)>=0) and ((ARecord.Values[id]-DQdate)<4) then
        AStyle:=DataLink_.QHuangSe
      else
      if ARecord.Values[id]-DQdate<0 then
      begin
        AStyle:=DataLink_OrderManage.FenHongS;
      end;
    end else
    begin

    end;
  except
  end; }
end;

procedure TfrmContractList_XF.v1DeliveryDateCustomDrawCell(
  Sender: TcxCustomGridTableView; ACanvas: TcxCanvas;
  AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
begin
 { Id:=TV1.GetColumnByFieldName('DeliveryDate').Index;//;-TV1.GroupedItemCount;
  Id10:=TV1.GetColumnByFieldName('SubStatus').Index;
  if Id<0 then Exit;
  if AViewInfo.GridRecord.Values[Id10]='完成' then Exit;
  if AViewInfo.GridRecord.Values[Id]-SGetServerDate(ADOQueryTemp)>=4 then Exit;
  if ((AViewInfo.GridRecord.Values[id]-SGetServerDate10(ADOQueryTemp))>=0) and ((AViewInfo.GridRecord.Values[id]-SGetServerDate(ADOQueryTemp))<4) then
    ACanvas.Brush.Color:=clYellow
  else
  if (AViewInfo.GridRecord.Values[id])-(SGetServerDate10(ADOQueryTemp)<0) then
  begin
    ACanvas.Brush.Color:=clRed;
  end;
  begin
    ACanvas.Brush.Color:=clRed;
  end else
  if AViewInfo.GridRecord.Values[Id]='Purple' then
  begin
    ACanvas.Brush.Color:=clPurple;
  end else
  if AViewInfo.GridRecord.Values[Id]='Olive' then
  begin
    ACanvas.Brush.Color:=clOlive;
  end else
  if AViewInfo.GridRecord.Values[Id]='Teal' then
  begin
    ACanvas.Brush.Color:=clTeal;
  end else
  if AViewInfo.GridRecord.Values[Id]='Background' then
  begin
    ACanvas.Brush.Color:=clBackground;
  end;   }
end;

procedure TfrmContractList_XF.N1Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno:string;
begin
  if Order_Main.IsEmpty then Exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\生产指示单10.rmf' ;
  SDofilter(ADOQueryMain,' OrderNoM='''+Trim(Order_Main.fieldbyname('OrderNoM').AsString)+'''');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Porderno:=Trim(Order_Main.fieldbyname('OrderNoM').AsString);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['begindate']:=begindate.DateTime;
    //RMVariables['enddate']:=enddate.DateTime;
    //RMVariables['printtime']:=Now;
    //RMVariables['printer']:=Trim(gUserName);
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\生产指示单10.rmf'),'提示',0);
  end;
  SDofilter(ADOQueryMain,'');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Order_Main.Locate('ordernoM',Porderno,[]);
end;

procedure TfrmContractList_XF.N2Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno:string;
begin
  if Order_Main.IsEmpty then Exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\生产指示单.rmf' ;
  SDofilter(ADOQueryMain,' OrderNoM='''+Trim(Order_Main.fieldbyname('OrderNoM').AsString)+'''');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Porderno:=Trim(Order_Main.fieldbyname('OrderNoM').AsString);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['begindate']:=begindate.DateTime;
    //RMVariables['enddate']:=enddate.DateTime;
    //RMVariables['printtime']:=Now;
    //RMVariables['printer']:=Trim(gUserName);
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\生产指示单.rmf'),'提示',0);
  end;
  SDofilter(ADOQueryMain,'');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Order_Main.Locate('ordernoM',Porderno,[]);
end;

procedure TfrmContractList_XF.ToolButton1Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  try
    frmConInPutXF:=TfrmConInPutXF.Create(Application);
    with frmConInPutXF do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
      ToolBar2.Visible:=False;
      TBSave.Visible:=False;
      ScrollBox1.Enabled:=False;
      Tv1.OptionsSelection.CellSelect:=False;
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmConInPutXF.Free;
  end;
end;

procedure TfrmContractList_XF.TcopyClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  try
    frmConInPutXF:=TfrmConInPutXF.Create(Application);
    with frmConInPutXF do
    begin
      PState:=1;
      CopyInt:=99;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmConInPutXF.Free;
  end;
end;

procedure TfrmContractList_XF.CustomerNoChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmContractList_XF.ConNoMKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
  begin
    if Length(connoM.Text)<3 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        SQL.Clear;
        sql.Add('select A.*,A.ConNo ConNoM ');
        sql.add(',SJFHMoney=(select Sum(B.Money) from YF_Money_CR B where B.CRType=''应收款登记'' and B.ConNO=A.ConNO) ');
        sql.add(',RLRMBMoney=(select Sum(RLMoney) from JYOrderYSK S where S.Mainid=A.Mainid and S.BZType=''￥'')');
        sql.add(',RLUSDMoney=(select Sum(RLMoney) from JYOrderYSK S where S.Mainid=A.Mainid and S.BZType=''$'')');
        SQL.Add(',PRTOrderQty=(select Sum(PRTOrderQty) from JYOrderCon_Sub B where B.MainId=A.MainId)');
        SQL.Add(',ConMoney=(select Sum(PRTOrderQty*PRTPrice) from JYOrderCon_Sub B where B.MainId=A.MainId)');
        SQL.Add(',OrderUnit=(select top 1 OrderUnit from JYOrderCon_Sub B where B.MainId=A.MainId)');
        SQL.Add(',PriceUnit=(select top 1 PriceUnit from JYOrderCon_Sub B where B.MainId=A.MainId)');
        SQL.Add(',PRTPrice=(select top 1 PRTPrice from JYOrderCon_Sub B where B.MainId=A.MainId)');
        sql.Add(' from JYOrderCon_Main A  ');
        SQL.Add('where  OrdDate>='''+'1899-01-01'+'''');
        SQL.Add('and  OrdDate<'''+'2050-01-01'+'''');
        sql.Add(' and MPRTType=''外销'' ');
        if Trim(DParameters1)<>'高权限'  then
        begin
            sql.Add('and A.Filler='''+Trim(DName)+'''');
        end;
        sql.Add(' and ConNo like '''+'%'+Trim(ConNoM.Text)+'%'+'''');
        Open;
      end;
      SCreateCDS20(ADOQueryMain,Order_Main);
      SInitCDSData20(ADOQueryMain,Order_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;
end;

procedure TfrmContractList_XF.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();
  TBRafresh.Click;
end;

procedure TfrmContractList_XF.TTJClick(Sender: TObject);
begin
 if Order_Main.IsEmpty then exit;
 if Trim(Order_Main.fieldbyname('filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('不能操作他人的数据!','提示',0);
    Exit;
  end;
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrdercon_Main SET status=''1''');
      sql.Add(' ,ConPerson2='+quotedstr(trim(DName)));
      sql.Add(' ,ConDefDate2=getdate() ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('外销合同审核')));
      sql.Add(','+quotedstr(trim('合同号：'+trim(Order_Main.FieldByName('conNo').AsString))));
      sql.Add(','+quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('操作成功！','提示信息');
    TBRafresh.Click;
  except
   application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmContractList_XF.TnoTJClick(Sender: TObject);
begin
 if Order_Main.IsEmpty then exit;
 if Trim(Order_Main.fieldbyname('filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('不能操作他人的数据!','提示',0);
    Exit;
  end;
  try
    {with ADOQueryTemp do
    begin
      close;
      sql.Clear;
      sql.add('select * from JYOrder_Main where ConNo='''+trim(Order_Main.fieldbyname('ConNo').AsString)+''' ');
      open;
      if not isempty then
      begin
        application.MessageBox('已生成指示单，不能撤销','提示');
        exit;
      end;
    end;}

    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrdercon_Main SET status=''0'',ConPerson2=null,ConDefDate2=null ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('外销合同撤销审核')));
      sql.Add(','+quotedstr(trim('合同号：'+trim(Order_Main.FieldByName('conNo').AsString))));
      sql.Add(','+quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('撤销成功！','提示信息');
    TBRafresh.Click;
  except
   application.MessageBox('撤销失败！','提示信息',0);
  end;
end;

procedure TfrmContractList_XF.Tv1FocusedRecordChanged(
  Sender: TcxCustomGridTableView; APrevFocusedRecord,
  AFocusedRecord: TcxCustomGridRecord;
  ANewItemRecordFocusingChanged: Boolean);
begin
  InitSub();
end;

procedure TfrmContractList_XF.Image2Click(Sender: TObject);
begin
  Panel4.Visible:=False;
end;

procedure TfrmContractList_XF.TBPrintClick(Sender: TObject);
var
   fPrintFile:string;
   EngMoney:string;
begin
  if Order_Main.IsEmpty then Exit;
  Button1.Click;
end;

procedure TfrmContractList_XF.Button1Click(Sender: TObject);
var
   fPrintFile:string;
   EngMoney:string;
   FimageFile: string;
begin
  FimageFile:='';
  if Order_Main.IsEmpty then Exit;
  if radiogroup1.ItemIndex=0 then
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\外销合同.rmf' ;
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
    sql.Add('select A.*,B.*,ConMoney=B.PRTOrderQty*B.PRTPrice  ');
    sql.Add(',DEFstr3=(select C.DEFstr3 from KH_Zdy_Attachment C where C.Type=''KHName'' and A.CustomerNoName=C.ZdyName)');
    sql.Add(',DEFstr4=(select C.DEFstr4 from KH_Zdy_Attachment C where C.Type=''KHName'' and A.CustomerNoName=C.ZdyName)');
    sql.Add(' from JYOrderCon_Main A inner join JYOrderCon_Sub B on A.MainId=B.MainId ');
    sql.Add(' where A.MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryPrint,CDS_Print);
  SInitCDSData20(ADOQueryPrint,CDS_Print);
  if FileExists(fPrintFile) then
  begin
    RMVariables['ImageFile']:=trim(FimageFile);
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\外销合同.rmf'),'提示',0);
  end;
end;

procedure TfrmContractList_XF.ToolButton2Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  try
    frmFjList_RZ:=TfrmFjList_RZ.Create(Application);
    with frmFjList_RZ do
    begin
      fkeyNO:=Trim(Self.Order_Main.fieldbyname('ConNo').AsString);
      fType:='合同';
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmFjList_RZ.Free;
  end;
end;

procedure TfrmContractList_XF.ToolButton3Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then exit;
  if (cxTabControl1.TabIndex<>2) or (cxTabControl1.TabIndex<>4) then exit;
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrdercon_Main SET status=''3''');
      sql.Add(' ,ConPerson2='+quotedstr(trim(DName)));
      sql.Add(' ,ConDefDate2=getdate() ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('外销合同审核')));
      sql.Add(','+quotedstr(trim('合同号：'+trim(Order_Main.FieldByName('conNo').AsString))));
      sql.Add(','+quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('操作成功！','提示信息');
    TBRafresh.Click;
  except
   application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmContractList_XF.ToolButton4Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then exit;
  if (cxTabControl1.TabIndex<>3) or (cxTabControl1.TabIndex<>4) then exit;
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrdercon_Main SET status=''0''');
      sql.Add(' ,ConPerson2='+quotedstr(trim(DName)));
      sql.Add(' ,ConDefDate2=getdate() ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('外销合同审核')));
      sql.Add(','+quotedstr(trim('合同号：'+trim(Order_Main.FieldByName('conNo').AsString))));
      sql.Add(','+quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('操作成功！','提示信息');
    TBRafresh.Click;
  except
   application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmContractList_XF.ToolButton5Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then exit;
  if cxTabControl1.TabIndex<>2 then exit;
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update JYOrdercon_Main SET IFCK=''是''');
      sql.Add(' where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      execsql;
    end;
    application.MessageBox('操作成功！','提示信息');
    TBRafresh.Click;
  except
   application.MessageBox('操作失败！','提示信息',0);
  end;
end;

end.
